﻿import Simple3dCamera;

class BouncingBall extends MovieClip {
	// 3d position:
	public var x:Number;
	public var y:Number;
	public var z:Number;
	
	// 3d velocity:
	private var yvel:Number=0;
	
	// reference to shadow clip:
	private var shadow:MovieClip;

	private function BouncingBall() {
		// ensure we get cast right off the bat:
		onEnterFrame();
	}
	
	private function onEnterFrame():Void {
		// gravity:
		yvel += 4
		y += yvel;
		
		// bounce:
		if (y > 0) {
			yvel *= -1;
			y = 0;
		}
		
		// move towards camera:
		z -= 10;
		if (z < 30) { shadow.removeMovieClip(); this.removeMovieClip(); }
		
		// update shadow:
		shadow.x = x;
		shadow.z = z;
		
		// cast to 2d:
		Simple3dCamera.cast(this);
		Simple3dCamera.cast(shadow);
		
		// adjust shadow:
		shadow._alpha = 100+y*0.5;
		shadow._xscale = (shadow._yscale *= 1-y/100);
	}
}