﻿import Simple3dCamera;

class ShowerBall extends MovieClip {
	// 3d position:
	private var x:Number;
	private var y:Number;
	private var z:Number;
	
	// 3d velocity:
	private var yvel:Number;
	private var xvel:Number;
	private var zvel:Number;
	
	// background clip to colorize:
	private var bg:MovieClip;
	
	private function ShowerBall() {
		// start with random velocities:
		xvel = random(30)-15;
		zvel = random(30)-15;
		yvel = -30-random(30);
		
		// ensure we get cast right off the bat:
		onEnterFrame();
		
		// give this sprite a random color:
		var c:Color = new Color(bg);
		c.setRGB(random(0xFFFFFF));
	}
	
	private function onEnterFrame():Void {
		// gravity:
		yvel += 4
		
		// move in 3d:
		y += yvel;
		z += zvel;
		x += xvel;
		
		// cast to 2d:
		Simple3dCamera.cast(this);
		
		// remove me if outside bounds:
		if (z < 10 || _x<-275 || _x>275 || _y>400) { this.removeMovieClip(); }
	}
}