﻿class Simple3dCamera {
	// focal distance is much the same as in a real camera.
	// lower number is more fish-eyed, higher is tele-photo.
	public static var focalDistance:Number=350;
	
	// the camera can have a position in the 3d space as well:
	public static var y:Number=-100;
	public static var x:Number=0;
	
	public static function cast(p_clip:MovieClip):Void {
		// perspective is a function of focal distance and z distance:
		var perspective:Number = focalDistance/p_clip.z;
		
		// use perspective to determine scaling:
		p_clip._xscale = p_clip._yscale = perspective*100;
		
		// use perspective to determine 2d positioning
		// note that the 3d x and y are determined relative to the camera
		p_clip._x = (p_clip.x-x)*perspective;
		p_clip._y = (p_clip.y-y)*perspective;
		
		// choose a depth based on z distance (could use real distance here):
		var depth:Number = 1000000-p_clip.z*100;
		
		// cycle through depths to ensure we have an empty depth:
		while (p_clip._parent.getInstanceAtDepth(depth)) { depth++; }
		
		// swap depths:
		p_clip.swapDepths(depth);
	}
}